# Revision history for uniqueness-periods-vector-examples

## 0.1.0.0 -- 2020-09-09

* First version. Released on an unsuspecting world.

## 0.1.2.0 -- 2020-09-11

* First version revised B. Changed the dependency boundaries for the uniqueness-periods-vector-general package.

## 0.1.3.0 -- 2020-09-12

* First version revised C. Changed the dependency boundaries for some changed packages from the uniqueness-periods-vector series. Made the needed code changes.

## 0.2.0.0 -- 2020-09-13

* Second version. Changed the dependency boundaries of the uniqueness-periods-vector-general package. Added a new executable uniqVec02.

## 0.3.0.0 -- 2020-09-15

* Third version. Added a new executable uniqVec03. It tests a hypothesis that for many Ukrainian poems (for example, by Oleksandr Oles) the actual
diverse2 output lies close between midpoint between the minimum and maximum possible for that line values.

## 0.3.1.0 -- 2020-09-15

* Third version revised A. Some code improvements for uniqVec03 executable for filtering non-Ukrainian texts parts that must not be inlined.

## 0.3.1.1 -- 2020-09-16

* Third version revised B. Changed the order of the output information for uniqVec03 executable, used tabutation symbols as delimiter, some code improvements.

## 0.4.0.0 -- 2020-09-17

* Fourth version. Added a README.md file. Changed the behaviour of the uniqVec03 executable so that it is more accurate and gives more output information.
Added links to results of the processment for the Ukrainian poetic original and translated-into texts.

## 0.5.0.0 -- 2020-09-19

* Fifth version. Added more information to the uniqVec03 output. Now it shows additionally the matrix of the words-per-line x number-of-the-interval in two different ways (the first one is
just a simple visualization in ASCII). Besides, it counts totals on the words-per-line and prints it, added the possibility to change the number of the intervals as the second
command line argument, and made some dependency changing related changes. Changed the dependency bounds for uniqueness-periods-vector-filters package. Added new dependency
of uniqueness-periods-vector-stats package.

## 0.5.1.0 -- 2020-09-19

* Fifth version revised A. Changed the dependency bounds of uniqueness-periods-vector-stats and used function from there in uniqVec03 executable.

## 0.5.2.0 -- 2020-09-19

* Fifth version revised B. Fixed issue with parse error for the uniqVec03 executable in the CPP preprocessor.

## 0.5.3.0 -- 2020-09-20

* Fifth version revised C. Fixed issue with parsing empty second command line argument (or its absense, actually).

## 0.6.0.0 -- 2020-09-25

* Sixth version. Changed dependency boundaries. Added parallel as a new dependency. Switched to parallel version of the uniqVec03 program. Added ghc-options section to the uniqVec03 executable.

## 0.6.1.0 -- 2020-09-25

* Sixth version revised A. Changed dependency boundaries. Fixed by this issues with the wrong text subpartitions.

## 0.7.0.0 -- 2020-09-28

* Seventh version. Changed dependency boundaries. Fixed multiple issues with the uniqVec03 executable.
Some comments in the code improvements. Introduced two more command line options -- the third and the fourth ones to control whether to print the line of
the text being analyzed and whether to transform the text into a monolythic one-line String before processment respectively.

## 0.7.1.0 -- 2020-09-28

* Seventh version revised A. Fixed issue with ambiguous importing for GHC-7.8* series in the uniqVec03 executable Main.hs module.

## 0.7.2.0 -- 2020-10-02

* Seventh version revised B. Added additional information so that also is displayed the percentages of intervals in the uniqVec03 executable. Parallelization
(and mostly performance) optimizations for uniqVec03 executable.

## 0.8.0.0 -- 2020-10-05

* Eigth version. Added a new way to compare the results for processment of the uniqVec03 executable. Added the fifth command line argument to control this
comparisons. Added a new lightweight dependency of lists-flines. Changed the names of the executables.

uniqVec01 -> lineVariants

uniqVec02 -> rewritePoem

uniqVec03 -> processText

## 0.8.0.1 -- 2020-10-05

* Eigth version revised A. Fixed issue with wrong import statements order in the code for processText executable.

## 0.8.0.2 -- 2020-10-05

* Eigth version revised B. Fixed issue with Sturges' rule and the respective function in the processText executable. For more information, please, see:
Sturges H. (1926). The choice of a class-interval. J. Amer. Statist. Assoc., 21, 65-66.

## 0.8.0.3 -- 2020-10-05

* Eigth version revised C. Fixed issues with README.md file inaccuracies and for double import of the mconcat function.

## 0.9.0.0 -- 2020-10-06

* Ninth version. Added the sixth command line argument except those ones in RTS for the processText executable to control whether if the executable is
working in comparative mode printing two analyses at a time then to evaluate them in parallel or sequentially. The default one is in parallel, but if you
would like to use possibly less resources then you can evaluate them in sequence. Some minor code improvements.

## 0.9.1.0 -- 2020-10-06

* Ninth version revised A. Fixed several issues with rewritePoem executable related to dependencies issues. Updated the dependencies bounds.

## 0.10.0.0 -- 2020-10-07

* Tenth version. Changed the behaviour of the lineVariants and rewritePoem executables. Now you can introspect the inner structure of the variants of the line or for the whole text. Added build dependencies to it (they are already included for other executables). Updated the versions because of better printing output.

## 0.11.0.0 -- 2020-10-09

* Eleventh version. Switched to the new versions of the uniqueness-periods-common and related packages, so that it can be more flexible in the future.
The breaking change. Please, update the packages to the latest version available.

## 0.12.0.0 -- 2020-10-10

* Twelfth version. Updated dependencies, switched to the [Float] only versions of the FuncRep and inner functions. Introduced a new textual command line
argument that allows to choose which metrices (called \"properties\") to use from uniqueness-periods-vector-properties package. Made a package
containing also two libraries which shares the common functions.

## 0.12.1.0 -- 2020-10-10

* Twelfth version revised A. Fixed issue with wrongly defined control parameters in the lineVariants executable.

## 0.12.2.0 -- 2020-10-12

* Twelfth version revised B. Improved printing of the output for the processText executable, used for this a new function precChoice.

## 0.12.3.0 -- 2020-10-12

* Twelfth version revised C. Improved printing of the output for the processText executable, used for this a new function precChoice. Fixed issue with
dependency function uniquenessVariants2GNP that influenced all the related functionality.

## 0.12.3.1 -- 2020-10-14

* Twelfth version revised D. Some code improvements.
